﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Automation;

using MS.Internal.Mita.Foundation.Waiters;
//Demo Cached Property
//Demo Node Verification
//Demo Event
//Demo Polling
//Demo Simple Engine
//Demo Code Generation
//Demo ControlTree/RawTree/ContentTree  System.Windows.Automation.Automation.RawViewCondition,

//Use Reflector to understand UIA Client API
//Use Reflector to understand UI Spy
//WaitForReady? UISync?
//Waiter Pattern
//Event internal and interface IProxyProviderWinEventSink
//USER32!SetWinEventHook

namespace UITestClient
{
    class Program
    {
        static void Main(string[] args)
        {
            //DemoCachedProperty.Test();

            DemoSimpleEngine.CaculatorTest();
            Console.ReadLine();
            return;
            //int[] list =new int[] { 30004, 30002, 30010, 30006, 30015, 30007, 30014, 30019, 30008, 30018, 30009, 30022, 30013};
            //foreach (var id in list)
            //{
                
            //    string name=AutomationProperty.LookupById(id).ProgrammaticName;
            //    Console.WriteLine(string.Format("{0} - {1}",id,name));
            //}
            //ClassName MSBLWindowClass System.String 


            AutomationElement btn;
            //btn.Current.IsEnabled;
            
            
            
            btn = AutomationElement.RootElement.FindFirst(TreeScope.Children, new PropertyCondition(AutomationElement.NameProperty, "Window1"));
            //bool b = VerifyEle(btn); 
            DumpTree(btn, 0);
            return;
            
            TreeWalker walker = new TreeWalker(Condition.TrueCondition);
            

            AutomationElement firstchild=walker.GetFirstChild(btn);
            AutomationElement last=walker.GetLastChild(btn);
            while (firstchild != last)
            {
                if (firstchild == btn)
                {
                }
                var parent = walker.GetParent(firstchild);
                
                Console.WriteLine("Parent:");
                Console.WriteLine(parent.Current.Name);                
                Console.WriteLine(firstchild.Current.Name);
                firstchild=walker.GetNextSibling(firstchild);                
            }

            //b = VerifyEle(firstchild); 

            var parent2 = walker.GetParent(firstchild);
            Console.WriteLine("Parent:");
            Console.WriteLine(parent2.Current.Name);
            Console.WriteLine(firstchild.Current.Name);
            
            
            // Set up the CacheRequest.
            CacheRequest cacheRequest = new CacheRequest();
            //cacheRequest.Add(AutomationElement.NameProperty);
            cacheRequest.TreeScope = TreeScope.Element | TreeScope.Children;
            

            // Activate the CacheRequest and get the element. Note that the scope of the CacheRequest
            // is in relation to the object being retrieved: the list box and its children are 
            // cached, not the main window and its children.
            using (cacheRequest.Activate())
            {
                // Load the list element and cache the specified properties for its descendants.
                //Condition cond = new PropertyCondition(AutomationElement.ControlTypeProperty, ControlType.List);
                btn = AutomationElement.RootElement.FindFirst(TreeScope.Children, new PropertyCondition(AutomationElement.AutomationIdProperty, "testForm"));

            }
            //btn.GetUpdatedCache(cacheRequest);

            for (int i = 0; i < btn.CachedChildren.Count; i++)
            {
                Console.WriteLine(btn.CachedChildren[i].Current.Name);
            }
        }

        static void DumpTree(AutomationElement ele, int index)
        {
            //if (VerifyElement(ele))
            //{
                StringBuilder sb = new StringBuilder();
                sb.Append('-', index*4);
                Console.WriteLine(string.Format("{0}{1}",sb.ToString(),ele.Current.Name));
            //}

            TreeWalker walker = new TreeWalker(Condition.TrueCondition);
            var start = walker.GetFirstChild(ele);
            var end = walker.GetLastChild(ele);
            if (start !=null && end!=null)
            {
                while (!start.Equals(end))
                {
                    DumpTree(start, index + 1);
                    start = walker.GetNextSibling(start);
                }
                DumpTree(start, index + 1);
            }
        }

        static bool VerifyElement(AutomationElement ele)
        {
            if (ele.Equals(AutomationElement.RootElement))
            {
                return true;
            }

            TreeWalker walker = new TreeWalker(Condition.TrueCondition);
            var parent = walker.GetParent(ele);
            if (parent == null)
            {
                return false;
            }           

            AutomationElement item = walker.GetFirstChild(parent);
            AutomationElement last = walker.GetLastChild(parent);

            if (item == null || last == null)
            {
                return false;
            }

            int max = 999;

            while (!item.Equals(last) && max>0)
            {
                if (item.Equals(ele))
                {
                    return true;
                }

                max--;

                item = walker.GetNextSibling(item);
            }

            if (max <= 0)
            {
                return false;
            }

            if (item.Equals(ele))
            {
                return true;
            }

            return false;
        }
    }
   
}
