﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace WPFUIAutoTarget
{
    /// <summary>
    /// Interaction logic for FlashWindow.xaml
    /// </summary>
    public partial class FlashWindow : Window
    {
        private DispatcherTimer livetimer;
        public FlashWindow(TimeSpan liveTime)
        {
            livetimer = new DispatcherTimer();
            livetimer.Interval = liveTime;
            livetimer.Tick += new EventHandler(livetimer_Tick);
            InitializeComponent();
            this.Name = "FlashWindow";
            //livetimer.IsEnabled = true;           
        }

        void livetimer_Tick(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
